=== debian/changelog ===
ros-indigo-octomap (1.6.9-0trusty) trusty; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Armin Hornung <armin@hornung.io>  Wed, 13 Jan 2016 22:01:28 -0000
